"use strict";

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.split.js");

var _react = _interopRequireWildcard(require("react"));

var _highlight = _interopRequireDefault(require("highlight.js"));

var _reactVirtualized = require("react-virtualized");

require("./Highlight.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function Highlight(_ref) {
  let {
    language = 'language-plaintext',
    fontSize = 14,
    rowHeight = 30,
    text = ''
  } = _ref;
  const textRows = text.split('\n');
  const rowRefs = (0, _react.useRef)([]);

  const updateRefs = () => {
    var _rowRefs$current;

    rowRefs === null || rowRefs === void 0 ? void 0 : (_rowRefs$current = rowRefs.current) === null || _rowRefs$current === void 0 ? void 0 : _rowRefs$current.forEach(ref => {
      if (ref.current != null) {
        _highlight.default.highlightElement(ref.current);
      }
    });
    rowRefs.current = [];
  };

  (0, _react.useEffect)(() => {
    updateRefs();
  }, [textRows]);

  const rowRenderer = _ref2 => {
    let {
      index,
      // isScrolling,
      key,
      style
    } = _ref2;
    // if (isScrolling) return <div key={key} style={style} />;
    const newRef = /*#__PURE__*/(0, _react.createRef)();
    rowRefs.current.push(newRef);
    return /*#__PURE__*/_react.default.createElement("div", {
      key: key,
      style: _objectSpread(_objectSpread({}, style), {}, {
        width: 'auto',
        fontSize: fontSize
      })
    }, /*#__PURE__*/_react.default.createElement("pre", null, /*#__PURE__*/_react.default.createElement("code", {
      ref: newRef,
      className: language
    }, textRows[index])));
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: "highlighter"
  }, /*#__PURE__*/_react.default.createElement(_reactVirtualized.AutoSizer, null, _ref3 => {
    let {
      width,
      height
    } = _ref3;
    return /*#__PURE__*/_react.default.createElement(_reactVirtualized.List, {
      className: "highlighterList",
      height: height,
      width: width,
      rowCount: textRows.length,
      rowHeight: rowHeight,
      rowRenderer: rowRenderer,
      overscanRowCount: 0,
      onRowsRendered: updateRefs
    });
  }));
}

var _default = Highlight;
exports.default = _default;